unit infcre_u;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, inifiles, Tabs, NetSales;

type
  TFormDSPMain = class(TForm)
    Panel2: TPanel;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Notebook: TNotebook;
    Label19: TLabel;
    Label18: TLabel;
    IniReadBtn: TSpeedButton;
    Label7: TLabel;
    Label8: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    AuthorName: TEdit;
    AuthorEMail: TEdit;
    AuthorURL: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Replaces: TEdit;
    d10cb: TCheckBox;
    d20cb: TCheckBox;
    d30cb: TCheckBox;
    c10cb: TCheckBox;
    SupportImage: TImage;
    Support: TCheckBox;
    Label4: TLabel;
    Description: TMemo;
    Label17: TLabel;
    DescrFile: TComboBox;
    d10a: TEdit;
    d20a: TEdit;
    d30a: TEdit;
    c10a: TEdit;
    Label6: TLabel;
    FileVersion: TEdit;
    Label3: TLabel;
    Label9: TLabel;
    FileStatus: TComboBox;
    Label10: TLabel;
    FullSource: TComboBox;
    Label11: TLabel;
    FileCategory: TComboBox;
    FName: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    LinkPanel: TPanel;
    KeepCopyOnDSPBtn: TSpeedButton;
    StoreOnlyLinkBtn: TSpeedButton;
    FileURL: TEdit;
    Label14: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label5: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label29: TLabel;
    Label13: TLabel;
    Label12: TLabel;
    AdditionalNote: TMemo;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    IniSaveBtn: TSpeedButton;
    Label44: TLabel;
    ClearBtn: TSpeedButton;
    NSPanel: TPanel;
    Label15: TLabel;
    NetSalesID: TEdit;
    NetSalesInfo: TMemo;
    Label16: TLabel;
    NetSalesLabel: TLabel;
    NSFirstBtn: TBitBtn;
    NSPriorBtn: TBitBtn;
    NSNextBtn: TBitBtn;
    NSLastBtn: TBitBtn;
    NSDeleteBtn: TBitBtn;
    NSAddBtn: TBitBtn;
    NextBtn: TBitBtn;
    BackBtn: TBitBtn;
    AboutBtn: TBitBtn;
    AfterSaveLabel: TLabel;
    PrevNameLabel: TLabel;
    AuthorPrevName: TEdit;
    SaveUploaderInfoBtn: TBitBtn;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
    procedure ClearAllFields;
    procedure ClearBtnClick(Sender: TObject);

    procedure IniReadBtnClick(Sender: TObject);
    procedure IniSaveBtnClick(Sender: TObject);

      { navigation through pages }
    procedure NextBtnClick(Sender: TObject);
    procedure BackBtnClick(Sender: TObject);
    procedure NotebookPageChanged(Sender: TObject);

    procedure SaveUploaderInfoBtnClick(Sender: TObject);
    procedure StoreOnlyLinkBtnClick(Sender: TObject);
    procedure KeepCopyOnDSPBtnClick(Sender: TObject);
      { keypreview for Help }
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

{ NetSales page procedures }
       { NotifyEvent from NetSales class }
    procedure WatchNetSales(Sender: TObject);
       { force to update item on exit }
    procedure NetSalesExit(Sender: TObject);
       { navigation through NetSales information }
    procedure NSNavigateBtnClick(Sender: TObject);
       { add more info to NetSales }
    procedure NSAddBtnClick(Sender: TObject);
       { remove infor from NetSales }
    procedure NSDeleteBtnClick(Sender: TObject);
    procedure SupportClick(Sender: TObject);
    procedure AuthorPrevNameExit(Sender: TObject);
    procedure AuthorNameExit(Sender: TObject);
    procedure AuthorInfoChanged(Sender: TObject);

    procedure WriteUploaderInfo(InfFile: TIniFile);

  private
    { Private declarations }

  public
    { Public declarations }
     InfFile  : TInifile;

  end;


var
  FormDSPMain: TFormDSPMain;

implementation

uses about_u, inf_cons, inf_util;

{$R *.DFM}



procedure TFormDSPMain.FormCreate(Sender: TObject);
var
  i: integer;

begin
  { create NetSales object }
  Net_Sales:= TNetSales.Create;
  Net_Sales.OnChange:= WatchNetSales;
  { force to first page }
  NoteBook.PageIndex:= 0;
  { read uploader information file kept in the same directory as executable }
  if FileExists(GetDirectory + c_UploaderInfoFile) then
  Begin
    infFile := Tinifile.Create(GetDirectory + c_UploaderInfoFile);
    with infFile do
    begin
      AuthorName.Text := ReadString(c_UploaderSection, c_AuthorName, '');
      AuthorEMail.Text := ReadString(c_UploaderSection, c_AuthorEmail, '');
      AuthorURL.text := ReadString(c_UploaderSection, c_AuthorURL, '');
      AuthorPrevName.Text:= ReadString(c_UploaderSection, c_AuthorPrevName, '');
      if Length(AuthorPrevName.Text) > 0 then
      Begin
        AuthorPrevName.Visible:= true;
        PrevNameLabel.Visible:= true;
      End else AuthorPrevName.Text:= AuthorName.Text;
      SaveUploaderInfoBtn.Enabled:= false;
      free;
    End;
  end else
  Begin
    ShowMessage('Please do save uploader information first.' + chr(13) +
                'This data will be kept in ' + chr(13) +
                GetDirectory + c_UploaderInfoFile + ' file.');
    NoteBook.PageIndex:= 1;
      { disable navigation buttons }
    NextBtn.Enabled:= false;
    BackBtn.Enabled:= false;
  End;
end;


procedure TFormDSPMain.WriteUploaderInfo;
Begin
  with InfFile do begin
    WriteString(c_UploaderSection, c_AuthorName, AuthorName.Text);
    WriteString(c_UploaderSection, c_AuthorEmail, AuthorEMail.Text);
    WriteString(c_UploaderSection, c_AuthorURL, AuthorURL.text);
    if AuthorPrevName.Visible then
     WriteString(c_UploaderSection, c_AuthorPrevName, AuthorPrevName.Text);
  End;
End;

procedure TFormDSPMain.IniSaveBtnClick(Sender: TObject);
var
  Ok     : Boolean;
begin
  ok := true;
  if Length(FileUrl.Text) = 0 then
   if Pos('.', FName.Text) > 0 then
    SaveDialog1.FileName:= Copy(FName.Text, 1, Pos('.', FName.Text)) + 'inf'
     else SaveDialog1.FileName:= '*.inf';

  If savedialog1.execute then
  begin
    DeleteFile(Savedialog1.Filename);
    infFile:= Tinifile.Create(Savedialog1.Filename);
    with infFile do
    begin
      { file info }
      WriteString(c_FileSection, c_Filename, FName.Text);
      WriteString(c_FileSection, c_Replacements, Replaces.Text);
      WriteString(c_FileSection, c_Version,FileVersion.Text);
      WriteString(c_FileSection, c_FileURL,FileUrl.Text);
      WriteString(c_FileSection, c_Description, StringsToString(Description.Lines));
      if d10cb.Checked then WriteString(c_FileSection, c_Delphi10, c_YES)
                           else WriteString(c_FileSection, c_Delphi10, c_NO);
      if d20cb.Checked then WriteString(c_FileSection, c_Delphi20, c_YES)
                           else WriteString(c_FileSection, c_Delphi20, c_NO);
      if d30cb.Checked then WriteString(c_FileSection, c_Delphi30, c_YES)
                           else WriteString(c_FileSection, c_Delphi30, c_NO);
      if c10cb.Checked then WriteString(c_FileSection, c_CPPB10, c_YES)
                           else WriteString(c_FileSection, c_CPPB10, c_NO);
      WriteString(c_FileSection, c_FileStatus, FileStatus.Text);
      WriteString(c_FileSection, c_FullSource, FullSource.Text);
      WriteString(c_FileSection, c_Category, FileCategory.Text);
      WriteString(c_FileSection, c_Note, StringsToString(AdditionalNote.Lines));
      WriteString(c_FileSection, c_AdditionalInfo, DescrFile.Text);
      { DSP support}
      if Support.Checked then WriteString(c_DSPSupport, c_DSPSupport, c_YES)
                         else WriteString(c_DSPSupport, c_DSPSupport, c_NO);
      { Available versions on DSP}
      WriteString(c_FileAvailableSection, c_delphi10, d10a.text);
      WriteString(c_FileAvailableSection, c_delphi20, d20a.text);
      WriteString(c_FileAvailableSection, c_delphi30, d30a.text);
      WriteString(c_FileAvailableSection, c_CPPB10, c10a.text);
      { uploader info }
      WriteUploaderInfo(InfFile);
      { NetSales Info }
      Net_Sales.WriteToIni(InfFile);
      Free;
    end;
    AfterSaveLabel.Visible:= true;
  end;
end;

procedure TFormDSPMain.IniReadBtnClick(Sender: TObject);
{var
  Temp     : String;
}
begin
  If opendialog1.execute then
  begin
    ClearAllFields;
    SaveDialog1.FileName:= OpenDialog1.Filename;
    infFile := Tinifile.Create(OpenDialog1.Filename);
    with infFile do
    begin
      FName.Text := ReadString(c_FileSection, c_Filename,'');
      Replaces.Text := ReadString(c_FileSection, c_Replacements,'');
      FileVersion.Text := ReadString(c_FileSection, c_Version,'');
      FileURL.Text := ReadString(c_FileSection, c_FileURL, '');
      LinkPanel.Visible:= Length(FileURL.Text) > 0;
                                                 
      Description.text := ReadString(c_FileSection, c_Description,'');

      DescrFile.ItemIndex:= DescrFile.Items.IndexOf(
        ReadString(c_FileSection,'Additional info', ''));

      d10cb.Checked:= CompareStr(ReadString(c_FileSection, c_delphi10, c_NO), c_YES) = 0;
      d20cb.Checked:= CompareStr(ReadString(c_FileSection, c_Delphi20, c_NO), c_YES) = 0;
      d30cb.Checked:= CompareStr(ReadString(c_FileSection, c_Delphi30, c_NO), c_YES) = 0;
      c10cb.Checked:= CompareStr(ReadString(c_FileSection, c_CPPB10, c_NO), c_YES) = 0;

      FileStatus.ItemIndex:= FileStatus.Items.IndexOf(
        ReadString(c_FileSection, c_FileStatus, ''));

      FullSource.ItemIndex:= FullSource.Items.IndexOf(
        ReadString(c_FileSection, c_FullSource,''));

      FileCategory.ItemIndex:= FileCategory.Items.IndexOf(
        ReadString(c_FileSection, c_Category,''));

      AdditionalNote.Text := ReadString(c_FileSection, c_Note,'');

      { Available info}
      d10a.text:= ReadString(c_FileAvailableSection, c_delphi10, '');
      d20a.text:= ReadString(c_FileAvailableSection, c_delphi20, '');
      d30a.text:= ReadString(c_FileAvailableSection, c_delphi30, '');
      c10a.text:= ReadString(c_FileAvailableSection, c_CPPB10, '');
        { Support }
      if CompareStr(ReadString(c_DSPSupport, c_DSPSupport, c_NO), c_YES) = 0
       then begin
         Support.Checked:= true;
         SupportImage.Visible:= true;
       End else Begin
         Support.Checked:= false;
         SupportImage.Visible:= false;
       End;

      Net_Sales.ReadFromIni(InfFile);
      Free;
    end;
  end;
end;

procedure TFormDSPMain.AboutBtnClick(Sender: TObject);
begin
  try
    FormAbout:= TFormAbout.Create(Self);
    FormAbout.showmodal;
  finally
    FormAbout.Destroy;
  End;
end;

procedure TFormDSPMain.ClearAllFields;
Begin
  { clear all fields except Uploader info }
    { UploadInfo page 1/3 }
  FName.Clear;
  FileURL.Clear;
  Replaces.Clear;
  LinkPanel.Visible:= false;
    { UploadInfo page 2/3 }
  FileVersion.Clear;
  FileStatus.ItemIndex := -1;
  FullSource.ItemIndex := -1;
  FileCategory.ItemIndex := -1;
    { UploadInfo page 3/3 }
  Description.Clear;
  DescrFile.ItemIndex:= -1;
    { compatibility page }
  d10cb.Checked:= false;
  d20cb.Checked:= false;
  d30cb.Checked:= false;
  c10cb.Checked:= false;
    { other files page }
  d10a.Clear;
  d20a.Clear;
  d30a.Clear;
  c10a.Clear;
    { Additional note page }
  AdditionalNote.Clear;
    { Support page}
  Support.Checked:= false;
  SupportImage.Visible:= false;
    { NetSales Page }
  Net_Sales.Clear;
End;

procedure TFormDSPMain.ClearBtnClick(Sender: TObject);
begin
  if messagedlg('Clear all fields ?', mtconfirmation,[mbYES,mbNo],0) = mrYES
   then Begin
     ClearAllFields;
     NoteBook.PageIndex:= 2;
     AfterSaveLabel.Visible:= false;
  End;
end;

procedure TFormDSPMain.NotebookPageChanged(Sender: TObject);
begin
  BackBtn.Enabled:= Notebook.PageIndex <> 0;
  NextBtn.Enabled:= Notebook.PageIndex <> Notebook.Pages.Count - 1;
end;

procedure TFormDSPMain.NextBtnClick(Sender: TObject);
begin
  if Notebook.PageIndex + 1 < Notebook.Pages.Count
    then Notebook.PageIndex:= Notebook.PageIndex + 1;
end;

procedure TFormDSPMain.BackBtnClick(Sender: TObject);
begin
  if Notebook.PageIndex > 0
   then Notebook.PageIndex:= Notebook.PageIndex - 1;
end;


procedure TFormDSPMain.SaveUploaderInfoBtnClick(Sender: TObject);
var
  Ok     : Boolean;
begin
  Ok:= true;
  if FileExists(GetDirectory + c_UploaderInfoFile) then
   if messagedlg('Overwrite existing file ' + c_UploaderInfoFile + ' ?',
        mtconfirmation,[mbYES,mbNo],0) = mrNo then ok := False;
  if ok then
  begin
    DeleteFile(GetDirectory + c_UploaderInfoFile);
    InfFile := Tinifile.Create(GetDirectory + c_UploaderInfoFile);
    WriteUploaderInfo(InfFile);
    infFile.Free;
    SaveUploaderInfoBtn.Enabled:= false;
    { enable navigation buttons }
    NotebookPageChanged(Notebook)
  end;
end;

procedure TFormDSPMain.StoreOnlyLinkBtnClick(Sender: TObject);
begin
  LinkPanel.Visible:= true;
  FileURL.SetFocus;
end;

procedure TFormDSPMain.KeepCopyOnDSPBtnClick(Sender: TObject);
begin
  FileURL.Clear;
  LinkPanel.Visible:= false;
end;


procedure TFormDSPMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F1 then
  Begin
    { display page }
    Application.HelpCommand(HELP_CONTEXT, 1000 + 10 * Notebook.PageIndex);
    key:= 0;
  End;
end;

procedure TFormDSPMain.NSAddBtnClick(Sender: TObject);
begin
  Net_Sales.Add_One('', '');
end;

procedure TFormDSPMain.FormDestroy(Sender: TObject);
begin
  Net_Sales.Destroy;
end;

procedure TFormDSPMain.WatchNetSales(Sender: TObject);
Begin
  if ( Net_Sales.Current <> - 1 ) then
  Begin
    if ( Net_Sales.Current < Net_Sales.Count - 1 ) then
    Begin
      NSNextBtn.Enabled:= true;
      NSLastBtn.Enabled:= true;
    End else
    Begin
      NSNextBtn.Enabled:= false;
      NSLastBtn.Enabled:= false;
    End;
    NSPriorBtn.Enabled:= Net_Sales.Current > 0;
    NSFirstBtn.Enabled:= Net_Sales.Current > 0;
    NetSalesLabel.Caption:= Format(' Item %d of %d items total ',
      [ Net_Sales.Current + 1, Net_Sales.Count ]);
    NetSalesID.Text:= Net_Sales.GetCurrentID;
    NetSalesInfo.Lines.Assign(Net_Sales.GetCurrentInfo);
  End;
  NSDeleteBtn.Enabled:= Net_Sales.Count > 0;
  NSPanel.Visible:= Net_Sales.Count > 0;
End;

procedure TFormDSPMain.NetSalesExit(Sender: TObject);
begin
  if Sender is TEdit
   then Net_Sales.UpdateCurrentID(NetSalesID.Text)
   else Net_Sales.UpdateCurrentInfo(TStringList(NetSalesInfo.Lines));
end;

procedure TFormDSPMain.NSNavigateBtnClick(Sender: TObject);
begin
  if Sender is TBitBtn then
  case TBitBtn(Sender).Tag of
    100: Net_Sales.First;
    101: Net_Sales.Prior;
    102: Net_Sales.Next;
    103: Net_Sales.Last;
  End;
end;

procedure TFormDSPMain.NSDeleteBtnClick(Sender: TObject);
begin
  Net_Sales.Delete_Current;
end;


procedure TFormDSPMain.SupportClick(Sender: TObject);
begin
  SupportImage.Visible:= Support.Checked;
end;

procedure TFormDSPMain.AuthorPrevNameExit(Sender: TObject);
begin
  if CompareStr(AuthorPrevName.Text, AuthorName.Text) = 0 then
  Begin
    AuthorPrevName.Visible:= false;
    PrevNameLabel.Visible:= false;
  End;
end;

procedure TFormDSPMain.AuthorNameExit(Sender: TObject);
begin
  if ( CompareStr( AuthorName.Text, AuthorPrevName.Text ) <> 0 ) and
    FileExists(GetDirectory + c_UploaderInfoFile) then
  Begin
    AuthorPrevName.Visible:= true;
    PrevNameLabel.Visible:= true;
  End;
end;

procedure TFormDSPMain.AuthorInfoChanged(Sender: TObject);
begin
  SaveUploaderInfoBtn.Enabled:= true;
end;

end.






